<?php

// +---------------------------------------------------------------------------+
// | userconfig Geeklog Plugin 1.0                                             |
// +---------------------------------------------------------------------------+
// | admin/index.php                                                           |
// | Administration page.                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by nmox                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// +---------------------------------------------------------------------------+
// | modified version 0.1                                                      |
// | 2008.4.20                                                                 |
// | Yoshinori Tahara as dengen                                                |
// +---------------------------------------------------------------------------+

require_once('../../../lib-common.php');

// 処理完了時の確認メッセージを表示させる:true , 表示させない:false
//$nmox_flag_show_message = true;
$nmox_flag_show_message = false;

// Only let admin users access this page
if (!SEC_hasRights('userconfig.edit')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the shop Admin page.  "
                ."User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_USERCONFIG['access_denied']);
    $display .= $LANG_USERCONFIG['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    echo $display;
    exit;
}

if (!defined ('UC_SELECTED')) {
//  define('UC_SELECTED', 'selected="selected"');
    define('UC_SELECTED', 'selected');
}

if (!defined ('UC_CHECKED')) {
//  define('UC_CHECKED', 'checked="checked"');
    define('UC_CHECKED', 'checked');
}

$LANG_ARRAY = array (
    'japanese'            => array( $LANG_USERCONFIG["lang_japanese"],           'ja' ),
    'english'             => array( $LANG_USERCONFIG["lang_english"],            'en' ),
    'spanish'             => array( $LANG_USERCONFIG["lang_spanish"],            'es' ),
    'bulgarian'           => array( $LANG_USERCONFIG["lang_bulgarian"],          'bg' ),
    'hebrew'              => array( $LANG_USERCONFIG["lang_hebrew"],             'he' ),
    'slovenian'           => array( $LANG_USERCONFIG["lang_slovenian"],          'sl' ),
    'romanian'            => array( $LANG_USERCONFIG["lang_romanian"],           'ro' ),
    'chinese_simplified'  => array( $LANG_USERCONFIG["lang_chinese_simplified"], 'zs' ),
    'croatian'            => array( $LANG_USERCONFIG["lang_croatian"],           'hr' ),
    'french_canada'       => array( $LANG_USERCONFIG["lang_french_canada"],      'fc' ),
    'catalan'             => array( $LANG_USERCONFIG["lang_catalan"],            'ca' ),
    'bosnian'             => array( $LANG_USERCONFIG["lang_bosnian"],            'bs' ),
    'danish'              => array( $LANG_USERCONFIG["lang_danish"],             'da' ),
    'french_france'       => array( $LANG_USERCONFIG["lang_french_france"],      'fr' ),
    'german_formal'       => array( $LANG_USERCONFIG["lang_german_formal"],      'df' ),
    'slovak'              => array( $LANG_USERCONFIG["lang_slovak"],             'sk' ),
    'czech'               => array( $LANG_USERCONFIG["lang_czech"],              'cs' ),
    'turkish'             => array( $LANG_USERCONFIG["lang_turkish"],            'tr' ),
    'portuguese_brazil'   => array( $LANG_USERCONFIG["lang_portuguese_brazil"],  'pb' ),
    'dutch'               => array( $LANG_USERCONFIG["lang_dutch"],              'nl' ),
    'italian'             => array( $LANG_USERCONFIG["lang_italian"],            'it' ),
    'indonesian'          => array( $LANG_USERCONFIG["lang_indonesian"],         'id' ),
    'portuguese'          => array( $LANG_USERCONFIG["lang_portuguese"],         'pt' ),
    'polish'              => array( $LANG_USERCONFIG["lang_polish"],             'pl' ),
    'finnish'             => array( $LANG_USERCONFIG["lang_finnish"],            'fi' ),
    'korean'              => array( $LANG_USERCONFIG["lang_korean"],             'ko' ),
    'afrikaans'           => array( $LANG_USERCONFIG["lang_afrikaans"],          'af' ),
    'swedish'             => array( $LANG_USERCONFIG["lang_swedish"],            'sv' ),
    'russian'             => array( $LANG_USERCONFIG["lang_russian"],            'ru' ),
    'farsi'               => array( $LANG_USERCONFIG["lang_farsi"],              'fa' ),
    'norwegian'           => array( $LANG_USERCONFIG["lang_norwegian"],          'no' ),
    'chinese_traditional' => array( $LANG_USERCONFIG["lang_chinese_traditional"],'zt' ),
    'spanish_argentina'   => array( $LANG_USERCONFIG["lang_spanish_argentina"],  'ea' ),
    'hellenic'            => array( $LANG_USERCONFIG["lang_hellenic"],           'el' ),
    'german'              => array( $LANG_USERCONFIG["lang_german"],             'de' ),
    'ukrainian'           => array( $LANG_USERCONFIG["lang_ukrainian"],          'uk' )
);

$CONF_TYPE = array (
    'show_right_blocks' => 'bool',
    'disable_new_user_registration' => 'bool',
    'loginrequired'                 => 'int',
    'submitloginrequired'           => 'int',
    'commentsloginrequired'         => 'int',
    'statsloginrequired'            => 'int',
    'searchloginrequired'           => 'int',
    'profileloginrequired'          => 'int',
    'emailuserloginrequired'        => 'int',
    'emailstoryloginrequired'       => 'int',
    'directoryloginrequired'        => 'int',
    'storysubmission'               => 'int',
    'usersubmission'                => 'int',
    'allow_user_themes'             => 'int',
    'allow_username_change'         => 'int',
    'allow_account_delete'          => 'int',
    'hide_author_exclusion'         => 'int',
    'allow_user_language'           => 'int',
    'allow_user_photo'              => 'int',
    'advanced_editor'               => 'bool',
    'listdraftstories'              => 'int',
    'limitnews'                     => 'int',
    'minnews'                       => 'int',
    'contributedbyline'             => 'int',
    'hideviewscount'                => 'int',
    'hideemailicon'                 => 'int',
    'hideprintericon'               => 'int',
    'allow_page_breaks'             => 'int',
    'draft_flag'                    => 'int',
    'frontpage'                     => 'int',
    'comment_code'                  => 'int',
    'hide_no_news_msg'              => 'int',
    'onlyrootfeatures'              => 'int',
    'maximagesperarticle'           => 'int',
    'max_image_width'               => 'int',
    'max_image_height'              => 'int',
    'max_image_size'                => 'int',
    'keep_unscaled_image'           => 'int',
    'show_topic_icon'               => 'int',
    'max_topicicon_width'           => 'int',
    'max_topicicon_height'          => 'int',
    'max_topicicon_size'            => 'int',
    'showstorycount'                => 'int',
    'showsubmissioncount'           => 'int',
    'hide_home_link'                => 'int',
    'hidenewstories'                => 'int',
    'hidenewcomments'               => 'int',
    'hidenewtrackbacks'             => 'int',
    'hidenewplugins'                => 'int',
    'title_trim_length'             => 'int',
    'newstoriesinterval'            => 'int',
    'newcommentsinterval'           => 'int',
    'newtrackbackinterval'          => 'int',
    'censormode'                    => 'int',
    'url_rewrite'                   => 'bool',
    'hide_main_page_navigation'     => 'int',
    'hour_mode'                     => 'int',
    'commentspeedlimit'             => 'int',
    'comment_limit'                 => 'int',
    'trackback_enabled'             => 'bool',
    'pingback_enabled'              => 'bool',
    'ping_enabled'                  => 'bool',
    'trackback_code'                => 'int',
    'trackbackspeedlimit'           => 'int',
    'check_trackback_link'          => 'int',
    'multiple_trackbacks'           => 'int',
    'pingback_self'                 => 'int',
    'backend'                       => 'int',
    'rdf_limit'                     => 'int',
    'rdf_storytext'                 => 'int',
    'syndication_max_headlines'     => 'int',
    'num_search_results'            => 'int',
    'default_perm_cookie_timeout'   => 'int',
    'session_cookie_timeout'        => 'int',
    'cookiesecure'                  => 'int',
    'lastlogin'                     => 'bool',
    'max_photo_width'               => 'int',
    'max_photo_height'              => 'int',
    'max_photo_size'                => 'int',
    'use_gravatar'                  => 'bool',
    'login_attempts'                => 'int',
    'login_speedlimit'              => 'int',
    'show_fullname'                 => 'int',
    'spamx'                         => 'int',
    'sort_admin'                    => 'bool',
    'skip_preview'                  => 'int',
    'rootdebug'                     => 'bool',
);

function nmox_settype( &$myconf ) {
    global $CONF_TYPE;
    
    foreach ((array)$myconf as $k => $v) {
       if ( isset( $CONF_TYPE[$k] ) ) {
           settype( $myconf[$k], $CONF_TYPE[$k] );
       }
    }
}

function nmox_setvar_menuitem($mval, &$T, &$n) {
    global $_CONF, $LANG_USERCONFIG_EDIT;
    
    $key = array_search($mval, $_CONF["menu_elements"]);
    $T->set_var('val_menu_value',     $mval);
    $T->set_var('lang_menu_name',     $LANG_USERCONFIG_EDIT["menu_".$mval]);
    $T->set_var('val_checked',        ($key !== false) ? UC_CHECKED : '');
    $T->set_var('val_menu_index',     $n++);
    $T->set_var('val_menusort_value', ($key !== false) ? ( ( $key + 1 ) * 10 ) : 999);
    $T->parse( 'menuitemlist', 'menuitem', true );
}

function nmox_setvar_text($key, &$T, $conf='') {
    global $_CONF;

    $T->set_var('val_'.$key, ($conf == '') ? $_CONF[$key] : $conf );
}

function nmox_setvar_radio($key, &$T, $iarray, $conf='') {
    global $_CONF;

    $conf = ($conf == '') ? $_CONF[$key] : $conf;
    foreach ((array)$iarray as $k => $n) {
        $T->set_var('val_'.$key.'_'.$k,  ( $conf == $n ) ? UC_CHECKED : '' );
    }
}

function nmox_setvar_select($key, &$T, $iarray, $conf='') {
    global $_CONF;

    $conf = ($conf == '') ? $_CONF[$key] : $conf;
    foreach ((array)$iarray as $k => $n) {
        $T->set_var('val_'.$key.'_'.$k,  ( $conf == $n ) ? UC_SELECTED : '' );
    }
}

function nmox_clearConfigFile() {
    global $_USERCONFIG;

    $fname = $_USERCONFIG['userconfig_now'];

    $fp = @fopen( $fname, 'w' );
    if ( $fp ) {
        $str = "<?php\n" . "?" . ">";
        $len = strlen( $str );
        @flock( $fp, LOCK_EX );
        @fwrite( $fp, $str, $len );
        @flock( $fp, LOCK_UN );
        @fclose( $fp );
        return true;
    } else {
        COM_errorLog( "Cannot open $fname for writing.", 1 );
    }
}

function nmox_writeConfigFile($myconf) {
    global $_CONF, $_USERCONFIG;

    unset($myconf['nmode']);
    $str = "\$_USERCONFIG_CONF = " . var_export($myconf,true) . ";\n";

    $fname = $_USERCONFIG['userconfig_now'];

    $fp = @fopen( $fname, 'w' );
    if ( $fp ) {
        $charset = mb_internal_encoding() ; //内部エンコード取得
        $str = mb_convert_encoding( $str, 
            strtoupper( $_CONF['default_charset'] ), $charset ) ; //内部エンコードからUTF-8に変換
        $str = "<?php\n" . $str . "\n" . '$_CONF = array_merge( $_CONF, $_USERCONFIG_CONF );' . "\n?" . ">";
        $len = strlen( $str );
        @flock( $fp, LOCK_EX );
        @fwrite( $fp, $str, $len );
        @flock( $fp, LOCK_UN );
        @fclose( $fp );
        return true;
    } else {
        COM_errorLog( "Cannot open $fname for writing.", 1 );
    }
}

/**
* @param    string    $parameter   the parameter to test
* @param    boolean   $isnumeric   true if $parameter is supposed to be numeric
* @return   string    the filtered parameter (may now be empty or 0)
*
*/
function nmox_applyFilter_one ( $parameter, $isnumeric = false ) {
    $p = COM_stripslashes( $parameter );
    $p = strip_tags( $p );
    $p = COM_killJS( $p ); // doesn't help a lot right now, but still ...

    if ( $isnumeric ) {
        // Note: PHP's is_numeric() accepts values like 4e4 as numeric
        if( !is_numeric( $p ) || ( preg_match( '/^-?\d+$/', $p ) == 0 )) {
            $p = 0;
        }
    } else {
        $p = preg_replace( '/\/\*.*/', '', $p );
        $pa = explode( "'", $p );
        $pa = explode( '"', $pa[0] );
        $pa = explode( '`', $pa[0] );
        $pa = explode( ';', $pa[0] );
//      $pa = explode( ',', $pa[0] ); // カンマはスルーする
        $pa = explode( '\\', $pa[0] );
        $p = $pa[0];
    }

    return $p;
}

function nmox_applyFilter($name, $is_num = false) {
    if (is_array($name)) {
        $res = array();
        foreach ((array)$name as $k => $n) {
            $res[$k] = nmox_applyFilter($n, $is_num);
        }
        return $res;
    } else {
        return nmox_applyFilter_one($name, $is_num);
    }
}


function nmox_editConfig () {
    global $_CONF, $LANG_USERCONFIG, $LANG_USERCONFIG_EDIT, $_USERCONFIG, $_USERCONFIG_CONF, $LANG_ARRAY;

    $retval = '';

    // テンプレートの生成
    if ( is_dir( $_CONF['path_layout'] . 'userconfig' ) ) {
        $T = new Template( $_CONF['path_layout'] . 'userconfig' );
    } else {
        $T = new Template( $_CONF['path'] . 'plugins/userconfig/templates' );
    }
    $T->set_file( array( 'edit'      => 'edit.thtml',
                         'menuitem'  => 'menuitem.thtml',
                         'themeitem' => 'themeitem.thtml',
                         'langitem'  => 'langitem.thtml'
                ) );
    $T->set_var('form_action', $_SERVER["PHP_SELF"]);

    // ナビゲーションバーの生成
    require_once ($_CONF['path_system'] . 'classes/navbar.class.php');
    $navbar = new navbar;
    $navbar->add_menuitem($LANG_USERCONFIG["setting_general"],      'showhideEditorDiv("page01",0);return false;',true);
    $navbar->add_menuitem($LANG_USERCONFIG["setting_userwork"],     'showhideEditorDiv("page02",1);return false;',true);
    $navbar->add_menuitem($LANG_USERCONFIG["setting_admin_general"],'showhideEditorDiv("page03",2);return false;',true);
    $navbar->add_menuitem($LANG_USERCONFIG["setting_locale"],       'showhideEditorDiv("page04",3);return false;',true);
    $navbar->add_menuitem($LANG_USERCONFIG["setting_contents"],     'showhideEditorDiv("page05",4);return false;',true);
    $navbar->add_menuitem($LANG_USERCONFIG["setting_blocks"],       'showhideEditorDiv("page06",5);return false;',true);
    $navbar->add_menuitem($LANG_USERCONFIG["setting_system"],       'showhideEditorDiv("page07",6);return false;',true);
    $navbar->add_menuitem($LANG_USERCONFIG["setting_all"],          'showhideEditorDiv("all",7)   ;return false;',true);

    $navbar->set_selected($LANG_USERCONFIG["setting_general"]);
    $T->set_var('navlist', $navbar->generate());
    
    foreach ($LANG_USERCONFIG_EDIT as $key => $val) {
        $T->set_var('lang_'.$key, $val);
    }

    // サイトの基本設定
    nmox_setvar_text('site_name', $T);
    nmox_setvar_text('site_slogan', $T);
    nmox_setvar_text('site_mail', $T);
    $themes = COM_getThemes();
    foreach ($themes as $theme) {
        $T->set_var('val_themeitem' , $theme);
        $T->set_var('val_selected' , ($_USERCONFIG_CONF["theme"] == $theme) ? ' ' . UC_SELECTED : '');
        $T->parse('selectthemes', 'themeitem', true);
    }

    // ヘッダメニュー
    $n=0;
    $elements = array('home'       => 0,
                      'contribute' => 0,
                      'search'     => 0,
                      'stats'      => 0,
                      'directory'  => 0,
                      'prefs'      => 0,
                      'plugins'    => 0,
                      'custom'     => 0
                     );
    foreach ($_CONF["menu_elements"] as $elem) {
        if ($elem != '') {
            nmox_setvar_menuitem($elem, $T, $n);
            $elements[$elem] = 1; // マーク
        }
    }
    foreach ($elements as $a => $b) {
        if ($b == 0) {
            if ($a != 'custom') {
                nmox_setvar_menuitem($a, $T, $n);
            } else if (function_exists( 'CUSTOM_menuEntries' )) {
                nmox_setvar_menuitem($a, $T, $n);
            }
        }
    }
    $T->set_var('val_menu_index_max', $n);

    // ブロック（サイドバー）
    nmox_setvar_select('show_right_blocks', $T, array( 1 => 1, 0 => 0 ));

    // URL
    nmox_setvar_select('url_rewrite', $T, array( 1 => 1, 0 => 0 ));

    // ページナビゲーション
    nmox_setvar_select('hide_main_page_navigation', $T, array( 1 => 1, 0 => 0 ));

    // 検索
    nmox_setvar_text('num_search_results', $T); // 追加

    // ユーザ
    nmox_setvar_select('disable_new_user_registration', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('show_fullname',                 $T, array( 1 => 1, 0 => 0 )); // 追加
    nmox_setvar_select('loginrequired',                 $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('submitloginrequired',           $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('commentsloginrequired',         $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('statsloginrequired',            $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('searchloginrequired',           $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('profileloginrequired',          $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('emailuserloginrequired',        $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('emailstoryloginrequired',       $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('directoryloginrequired',        $T, array( 1 => 1, 0 => 0 ));

    // 承認待ちリスト
    nmox_setvar_select('storysubmission',               $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('usersubmission',                $T, array( 1 => 1, 0 => 0 ));

    // ユーザの権利
    nmox_setvar_select('allow_user_themes',             $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('allow_username_change',         $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('allow_account_delete',          $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hide_author_exclusion',         $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('allow_user_language',           $T, array( 1 => 1, 0 => 0 )); // 追加
    nmox_setvar_select('allow_user_photo',              $T, array( 1 => 1, 0 => 0 )); // 追加 

    // アバター画像
    nmox_setvar_text('max_photo_width',  $T); // 追加
    nmox_setvar_text('max_photo_height', $T); // 追加
    nmox_setvar_text('max_photo_size',   $T); // 追加
    nmox_setvar_select('use_gravatar', $T, array( 1 => 1, 0 => 0 )); // 追加

    // 管理者運用設定
    nmox_setvar_select('advanced_editor', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('postmode', $T, array( 1 => 'html', 0 => 'plaintext' ));
    $T->set_var('val_notification_story',     (array_search('story',     $_CONF['notification']) !== false) ? UC_CHECKED : '' );
    $T->set_var('val_notification_comment',   (array_search('comment',   $_CONF['notification']) !== false) ? UC_CHECKED : '' );
    $T->set_var('val_notification_user',      (array_search('user',      $_CONF['notification']) !== false) ? UC_CHECKED : '' );
    $T->set_var('val_notification_trackback', (array_search('trackback', $_CONF['notification']) !== false) ? UC_CHECKED : '' );
    $T->set_var('val_notification_pingback',  (array_search('pingback',  $_CONF['notification']) !== false) ? UC_CHECKED : '' );
    nmox_setvar_select('listdraftstories', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('spamx', $T, array( 0 => 128, 1 => 8, 2 =>136 )); // 追加
    nmox_setvar_select('sort_admin', $T, array( 1 => 1, 0 => 0 )); // 追加
    nmox_setvar_select('skip_preview', $T, array( 1 => 1, 0 => 0 )); // 追加

    // 認証
    nmox_setvar_text('login_attempts',   $T); // 追加
    nmox_setvar_text('login_speedlimit', $T); // 追加

    // パーミッション（アクセス権）
    nmox_setvar_select('dpb01', $T, array( 3 => 3, 2 => 2, 0 => 0 ), $_CONF['default_permissions_block'][1]);
    nmox_setvar_select('dpb02', $T, array( 2 => 2, 0 => 0 ),         $_CONF['default_permissions_block'][2]);
    nmox_setvar_select('dpb03', $T, array( 2 => 2, 0 => 0 ),         $_CONF['default_permissions_block'][3]);
    nmox_setvar_select('dps01', $T, array( 3 => 3, 2 => 2, 0 => 0 ), $_CONF['default_permissions_story'][1]);
    nmox_setvar_select('dps02', $T, array( 2 => 2, 0 => 0 ),         $_CONF['default_permissions_story'][2]);
    nmox_setvar_select('dps03', $T, array( 2 => 2, 0 => 0 ),         $_CONF['default_permissions_story'][3]);
    nmox_setvar_select('dpt01', $T, array( 3 => 3, 2 => 2, 0 => 0 ), $_CONF['default_permissions_topic'][1]);
    nmox_setvar_select('dpt02', $T, array( 2 => 2, 0 => 0 ),         $_CONF['default_permissions_topic'][2]);
    nmox_setvar_select('dpt03', $T, array( 2 => 2, 0 => 0 ),         $_CONF['default_permissions_topic'][3]);

    // ドメイン
    nmox_setvar_text('allow_domains', $T);
    nmox_setvar_text('disallow_domains', $T);

    // バッドワード
    nmox_setvar_select('censormode', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_text('censorreplace', $T);
    nmox_setvar_text('censorlist', $T, implode(",", $_CONF["censorlist"]));

    // ロケール
    nmox_setvar_text('locale', $T);
    nmox_setvar_select('hour_mode', $T, array( 1 => 12, 0 => 24 ));
    nmox_setvar_text('date', $T);
    nmox_setvar_text('daytime', $T);
    nmox_setvar_text('shortdate', $T);
    nmox_setvar_text('dateonly', $T);
    nmox_setvar_text('timeonly', $T);
    nmox_setvar_select('week_start', $T, array( 1 => 'Sun', 0 => 'Mon' ));

    // 多言語
    nmox_setvar_select('language_flag', $T, array( 1 => 1, 0 => 0 ));

    $d=dir($_CONF['path']."language");
    $n=0;
    while (false !== ($language = $d->read())) {
        if(substr($language,-10)=="_utf-8.php"){
            $language_name=substr($language,0,-10);
            if(!empty($LANG_ARRAY[$language_name][0])){
                if(in_array(substr($language,0,-4),(isset($_CONF["language_files"])?$_CONF["language_files"]:array("no data")))){
                    $checked = ' ' . UC_CHECKED;
                }else{
                    $checked = '';
                }
                $T->set_var('val_lang_index' , $n);
                $T->set_var('val_lang_value' , $language_name);
                $T->set_var('val_checked'    , $checked);
                $T->set_var('val_lang_name'  , $LANG_ARRAY[$language_name][0]);
                $T->set_var('val_lang_name2' , $LANG_ARRAY[$language_name][1]);
                $T->parse('checklanguagelist', 'langitem', true);
                $n++;
            }
        }
    }
    $d->close();

    // 記事
    nmox_setvar_text('limitnews', $T);
    nmox_setvar_text('minnews', $T);
    nmox_setvar_select('contributedbyline', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hideviewscount',    $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hideemailicon',     $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hideprintericon',   $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('allow_page_breaks', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('draft_flag',        $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('frontpage',         $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hide_no_news_msg',  $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('onlyrootfeatures',  $T, array( 1 => 1, 0 => 0 ));

    // 記事の画像
    nmox_setvar_text('maximagesperarticle', $T);
    nmox_setvar_text('max_image_width', $T);
    nmox_setvar_text('max_image_height', $T);
    nmox_setvar_text('max_image_size', $T); // 追加
    nmox_setvar_select('keep_unscaled_image', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('image_lib', $T, array( 1 => '', 2 => 'gdlib', 3 => 'imagemagick', 4 => 'netpbm' ));

    // コメント
    nmox_setvar_select('comment_code', $T, array( 1 => 0, 0 => -1 ));
    nmox_setvar_text('commentspeedlimit', $T);
    nmox_setvar_text('comment_limit', $T);
    nmox_setvar_select('comment_mode', $T, array( 0 => 'threaded', 1 => 'nested', 2 => 'nocomments', 3 => 'flat' ));

    // 話題アイコン
    nmox_setvar_select('show_topic_icon', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('article_image_align', $T, array( 1 => 'left', 0 => 'right' ));
    nmox_setvar_text('max_topicicon_width', $T);
    nmox_setvar_text('max_topicicon_height', $T);
    nmox_setvar_text('max_topicicon_size', $T); // 追加

    // 話題ブロック
    nmox_setvar_select('showstorycount',      $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('showsubmissioncount', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hide_home_link',      $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('sortmethod',          $T, array( 0 => 'alpha', 1 => 'sortnum' )); // 追加

    // 新着情報ブロック
    nmox_setvar_select('hidenewstories',    $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hidenewcomments',   $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hidenewtrackbacks', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('hidenewplugins',    $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_text('title_trim_length', $T);
    nmox_setvar_text('newstoriesinterval', $T); // 追加
    nmox_setvar_text('newcommentsinterval', $T); // 追加
    nmox_setvar_text('newtrackbackinterval', $T); // 追加

    // Who's Onlineブロック
    nmox_setvar_text('whosonline_threshold', $T); // 追加
    nmox_setvar_select('whosonline_anonymous', $T, array( 1 => 1, 0 => 0 )); // 追加

    // トラックバック
    nmox_setvar_select('trackback_enabled', $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('pingback_enabled',  $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('ping_enabled',      $T, array( 1 => 1, 0 => 0 ));
    nmox_setvar_select('trackback_code',    $T, array( 1 => 0, 0 => -1 ));
    nmox_setvar_text('trackbackspeedlimit', $T);
    nmox_setvar_select('check_trackback_link', $T, array( 0 => 0, 1 => 1, 2 => 2, 3 => 3, 4 => 4, 5 => 5, 6 => 6, 7 => 7 ));
    nmox_setvar_select('multiple_trackbacks',  $T, array( 0 => 0, 1 => 1, 2 => 2 ));
    nmox_setvar_select('pingback_self',        $T, array( 0 => 0, 1 => 1, 2 => 2 ));

    // RSSフィード
    nmox_setvar_select('backend', $T, array( 1 => 1, 2 => 2 ));
    nmox_setvar_text('rdf_file', $T);
    nmox_setvar_text('rdf_limit', $T);
    nmox_setvar_text('rdf_storytext', $T);
    nmox_setvar_text('syndication_max_headlines', $T);

    // クッキー
    nmox_setvar_text('cookie_session',  $T); // 追加
    nmox_setvar_text('cookie_name',     $T); // 追加
    nmox_setvar_text('cookie_password', $T); // 追加
    nmox_setvar_text('cookie_theme',    $T); // 追加
    nmox_setvar_text('cookie_language', $T); // 追加
    nmox_setvar_text('default_perm_cookie_timeout', $T); // 追加
    nmox_setvar_text('session_cookie_timeout', $T); // 追加
    nmox_setvar_text('cookie_path',     $T); // 追加
    nmox_setvar_text('cookiedomain',    $T); // 追加
    nmox_setvar_select('cookiesecure', $T, array( 1 => 1, 0 => 0 )); // 追加
    nmox_setvar_select('lastlogin',    $T, array( 1 => 1, 0 => 0 )); // 追加

    // デバッグ
    nmox_setvar_select('rootdebug', $T, array( 1 => 1, 0 => 0 )); // 追加

    $T->parse( 'output', 'edit' );
    $retval .= $T->finish( $T->get_var( 'output' ) );
    return $retval;

}


function nmox_writeConfig () {
    global $_CONF, $LANG_USERCONFIG, $LANG_ARRAY, $CONF_TYPE, $nmox_flag_show_message;

    $retval = "";

    $myconf = nmox_applyFilter($_POST);
    nmox_settype( $myconf );

    if ( ! preg_match('/^[a-zA-Z0-9_\.\-]+?@[A-Za-z0-9_\.\-]+$/', $myconf["site_mail"]) ) {
        //site_mail is NG
        $retval = "
        <div align='center'>
        <br><strong>".$LANG_USERCONFIG["mail_error"]."</strong><br><br>
        <a href='index.php'>".$LANG_USERCONFIG["go_index"]."</a>
        </div>
        ";
        return $retval;
    }

    $languages = $myconf["language"];
    if (is_array($languages)) {
        $languages_array = array();
        $language_files_array = array();
        foreach ($languages as $language) {
            $languages_array[ $LANG_ARRAY[$language][1] ] = $LANG_ARRAY[$language][0];
            $language_files_array[ $LANG_ARRAY[$language][1] ] = $language."_utf-8";
        }
        $myconf['languages'] = $languages_array;
        $myconf['language_files'] = $language_files_array;
    } else {
        $myconf['languages'] = array();
        $myconf['language_files'] = array();
        $myconf['language_flag'] = '0';
    }

    $menusorts = $myconf["menusort"];
    $menus = $myconf["menus"];
    if (is_array($menus)) {
        for ($j=0; $j<count($menusorts)-1; $j++) {
            for ($i=0; $i<count($menusorts)-1; $i++) {
                if ( (int)$menusorts[$i] > (int)$menusorts[($i+1)] ) {
                
                    $temp1 = $menusorts[($i+1)];
                    $menusorts[($i+1)] = $menusorts[$i];
                    $menusorts[$i] = $temp1;
                    
                    $temp2 = $menus[($i+1)];
                    $menus[($i+1)] = $menus[$i];
                    $menus[$i] = $temp2;
                }
            }
        }
        ksort($menus);
        $myconf['menu_elements'] = $menus;
    } else {
        $myconf['menu_elements'] = $_CONF['menu_elements'];
    }
    
    $notis = $myconf["notis"];
    $notification = array();
    foreach ($notis as $note) {
        if (! empty($note)) $notification[] = $note;
    }
    $myconf['notification'] = $notification;

    $myconf['default_permissions_block'] = array(3, (int)$myconf["dpb01"], (int)$myconf["dpb02"], (int)$myconf["dpb03"] );
    $myconf['default_permissions_story'] = array(3, (int)$myconf["dps01"], (int)$myconf["dps02"], (int)$myconf["dps03"] );
    $myconf['default_permissions_topic'] = array(3, (int)$myconf["dpt01"], (int)$myconf["dpt02"], (int)$myconf["dpt03"] );

    $myconf['censorlist'] = explode(",", $myconf["censorlist"]);

    $myconf['layout_url']  = $_CONF['site_url'] . '/layout/' . $myconf['theme']; // theme
    $myconf['path_layout'] = $_CONF['path_themes'] . $myconf['theme'] . '/'; // theme
    
    unset( $myconf['language'], $myconf['menusort'], $myconf['menus'], $myconf['notis'],
           $myconf['dpb01'], $myconf['dpb02'], $myconf['dpb03'],
           $myconf['dps01'], $myconf['dps02'], $myconf['dps03'],
           $myconf['dpt01'], $myconf['dpt02'], $myconf['dpt03']
    );

    nmox_writeConfigFile($myconf);

    if ($nmox_flag_show_message) {
        $retval = "<meta http-equiv='refresh' content='0'><br><br><br><div align='center'>"
                 .$LANG_USERCONFIG["updating"]."</div><br><br><br>";
    }
    return $retval;
}


/**
* Main 
*/
$nmode = nmox_applyFilter($_POST["nmode"]);
if ( ! empty($nmode) ) {
    
    switch ($nmode) {
        case $LANG_USERCONFIG_EDIT["backup_button"]: // バックアップ
            $rows = file($_USERCONFIG['userconfig_now']);
            $fp = fopen($_USERCONFIG['userconfig_bak'],"w");
            foreach ($rows as $row) {
                fwrite($fp,$row);
            }
            fclose($fp);
            if ($nmox_flag_show_message) {
                $retval = "<div align='center'>".$LANG_USERCONFIG["finished_backup"]
                         ."<br><br><a href='".$_SERVER["PHP_SELF"]."'>OK</a></div>";
            }
            break;
            
        case $LANG_USERCONFIG_EDIT["restore_button"]: // リストア
            $rows = file($_USERCONFIG['userconfig_bak']);
            $fp = fopen($_USERCONFIG['userconfig_now'],"w");
            foreach($rows as $row) {
                fwrite($fp,$row);
            }
            fclose($fp);
            if ($nmox_flag_show_message) {
                $retval = "<div align='center'>".$LANG_USERCONFIG["finished_restore"]
                         ."<br><br><a href='".$_SERVER["PHP_SELF"]."'>OK</a></div>";
            }
            break;
            
        case $LANG_USERCONFIG_EDIT["submit"]: // 保存
            $retval = nmox_writeConfig();
            break;
            
        case $LANG_USERCONFIG_EDIT["default"]: // 初期化
            nmox_clearConfigFile();
            if ($nmox_flag_show_message) {
                $retval = "<div align='center'>".$LANG_USERCONFIG["return_default"]
                         ."<br><br><a href='".$_SERVER["PHP_SELF"]."'>OK</a></div>";
            }
            break;
    }
    if ($retval != '') {
        $display = COM_siteHeader(1);
        $display .= $retval;
        $display .= COM_siteFooter(1);
        echo $display;
    } else {
        header( "Location: " . $_CONF['site_admin_url'] . "/plugins/userconfig/index.php" );
    }
}

$display = COM_siteHeader();
$display .= nmox_editConfig(); // 編集
$display .= COM_siteFooter();

echo $display;
?>
