<?php
//
// +---------------------------------------------------------------------------+
// | userconfig Geeklog Plugin 1.0                                             |
// +---------------------------------------------------------------------------+
// | function.inc                                                              |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by nmox                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// +---------------------------------------------------------------------------+
// | modified version 0.1                                                      |
// | 2008.4.20                                                                 |
// | Yoshinori Tahara as dengen                                                |
// +---------------------------------------------------------------------------+

/**
* This is the generic functions.inc for the Universal Plugin Toolkit for Geeklog.
*/

/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/userconfig/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile))
{
    include_once ($langfile);
}
else
{
    include_once ($_CONF['path'] . 'plugins/userconfig/language/english.php');
}

require_once ($_CONF['path'] . 'plugins/userconfig/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

function plugin_chkVersion_userconfig() {
    global $_USERCONFIG;

    return $_USERCONFIG['version'];
}

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* Universal Plugin:  Uncomment and fill in variables;
* 
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_userconfig()
{
    global $_CONF, $LANG_USERCONFIG, $_USERCONFIG;

    //  if ($_USERCONFIG['hideuserconfigmenu'] == 0) {
    //$menuitems['Shop'] = $_CONF['site_url'] . '/userconfig/index.php';
    //  }
    return $menuitems;
}

/**
* Check to see if this Plugin uses comments
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_userconfig()
{
    return false;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* Universal Plugin:  Modify/uncomment use it
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_userconfig($showsitestats)
{
    $retval = '';
    return $retval;
}

function plugin_upgrade_userconfig ()
{
    global $_TABLES, $_USERCONFIG;

    $v = DB_getItem ($_TABLES['plugins'], 'pi_version', "pi_name = 'userconfig'");

    if ($v != $_USERCONFIG['version']) {
        // update version numbers
        DB_query ("UPDATE {$_TABLES['plugins']} SET pi_version = '{$_USERCONFIG['version']}', pi_gl_version = '1.4.1' WHERE pi_name = 'userconfig'");

        // check if version number was updated successfully
        $v = DB_getItem ($_TABLES['plugins'], 'pi_version', "pi_name = 'spamx'");
    }

    if ($v == $_USERCONFIG['version']) {
        return true;
    }

    return true;
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_userconfig($installCheck = '')
{
    global $_TABLES, $LANG_USERCONFIG,$_CONF,$_USERCONFIG;

    // The zencarts need to be changed to the name of your plugin
    //

    $pi_name  = 'userconfig';
    // Check and see if plugin is still enabled - if so display warning and exit

    // Ok to proceed and delete plugin

    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the userconfig plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'userconfig'",1);

    // Remove the Admin group definition for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}admingrpid'");
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}admingrpid'");
    COM_errorLog("Removing root users from Admin Group of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);

    // Remove User group definition for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_usersgrp_id'");
    COM_errorLog("Removing $pi_name User Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_usersgrp_id'");
    COM_errorLog("Removing root users from Users Group of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);

    $FEATURES = array ('userconfig.edit');
    // Remove all the associated features - access rights. The feature ID's were stored in the vars table during install.
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        COM_errorLog("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }
    // Drop zencart tables

    //unkink config_now.php
    
    unlink($_USERCONFIG['userconfig_now']);
    unlink($_USERCONFIG['userconfig_bak']);
    
    
    // Remove Security for this plugin
    COM_errorLog('...success',1);
    return true;
}

function plugin_getheadercode_userconfig(){
    global $_CONF, $_MYCALJP2_CONF;

    
    if ( file_exists( $_CONF['path_layout'] . 'userconfig/style.css' ) ) {
        $url = $_CONF['layout_url'] . '/userconfig/style.css';
    } else {
        $url = $_CONF['site_admin_url'] . '/plugins/userconfig/style.css';
    }

    return '
<!-- Include CSS for userconfig plugin -->
<link rel="stylesheet" type="text/css" href="' . $url . '">
';
}

function plugin_templatesetvars_userconfig($templatename, &$template) {
    if ($templatename == 'header') {
        //      if (isset($mycontent)) {
        //          $template->set_var( 'myvar', $mycontent );
        //      }
    }
}

//function plugin_getBlocks_userconfig($side, $topic=''){
//  $retval = '';
//
//  return $retval ;
//}

/**
* returns the administrative option for this plugin
*
*/
function plugin_getadminoption_userconfig(){
    global $_CONF, $_USERCONFIG, $_TABLES;

    if (SEC_hasRights ('userconfig.edit', 'OR')) {
        return array ($_USERCONFIG['userconfig'], $_CONF['site_admin_url'] . '/plugins/userconfig/index.php');
    }
}

function plugin_user_create_userconfig($uid) {
    global $_TABLES;
    
//  $result = DB_query("INSERT INTO {$_TABLES['pm_prefs']} (uid) VALUES ({$uid})");
}

// Notified that a user account is deleted.  Now, drop the record for this
// user in $_TABLE['pm_prefs'].

function plugin_user_delete_userconfig($uid) {
    global $_TABLES;
    
}
?>
